﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
   public class Counting
   {     
        public static double Prob_err(int n, int k, double p)
        { 
            double P_e= Math.Pow(1 - p, n);
            for (int j = 1; j <= k; j++)
            {
                P_e = P_e * p / (1 - p) * (n - j + 1) / j;               
            }         
            return P_e;         
        }
        public static double sum_binom(int n, int k, double p)
        {
            double sum = 0;   
            double P_ok = Math.Pow(1 - p, n);
            sum = P_ok; 
            for (int i = 1; i <= k; i++)
            {              
                P_ok = P_ok * p / (1 - p) * (n - i + 1) / i;               
                sum = sum + P_ok;               
            }
            return sum;
        }

        public static double Prob_success_with_check(int n, double p, int k, int h)
        {                   
            return Math.Pow(sum_binom(n, k, p), h);

        }

        public static double Prob_suc_without_check(int n, double p, int k, int h)
        {
            return sum_binom(n, k, 1-Math.Pow(1-p, h));
        }

        public static double Efficienty_strat1(int n, int h, double e1, double e2)
        {
            return Math.Pow((n * e1 + n * e2), h);
        }
        public static double Efficienty_strat2(int n, int h, double e1, double e2)
        {
            return h*n * e1 + n * e2;
        }

        public static double Strat1_bothsides(int n, double p, int k, int h, int l)
        {
            return Math.Pow(sum_binom(n, k, p), h) + Math.Pow(sum_binom(n, k, p), l-h) - Math.Pow(sum_binom(n, k, p), h) * Math.Pow(sum_binom(n, k, p), l - h);
        }

        public static double Strat2_bothsides(int n, double p, int k, int h, int l)
        {
            return sum_binom(n, k, 1 - Math.Pow(1 - p, h)) + sum_binom(n, k, 1 - Math.Pow(1 - p, l-h)) - sum_binom(n, k, 1 - Math.Pow(1 - p, h)) * sum_binom(n, k, 1 - Math.Pow(1 - p, l - h));
        }
    }

}
